## ros-kinetic-robot-calibration 0.6.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(robot_calibration)

if (CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wall")
endif()

find_package(Boost REQUIRED system thread)

find_library(tinyxml_library tinyxml)
if (tinyxml_library)
  message (STATUS "Looking for libtinyxml - found")
  set(tinyxml_LIBRARIES ${tinyxml_library})
endif ()
find_path(tinyxml_include_dirs NAMES tinyxml.h PATH_SUFFIXES tinyxml)
if (NOT tinyxml_include_dirs)
   message (STATUS "Looking for tinyxml/tinyxml.hpp or tinyxml/tinyxml.h - not found.")
endif ()

find_package(orocos_kdl)
find_package(Ceres REQUIRED)
find_package(OpenCV REQUIRED)
find_package(catkin REQUIRED
  COMPONENTS
    actionlib
    camera_calibration_parsers
    cv_bridge
    geometry_msgs
    kdl_parser
    moveit_msgs
    nav_msgs
    pluginlib
    robot_calibration_msgs
    rosbag
    roscpp
    sensor_msgs
    std_msgs
    tf
    tf2_geometry_msgs
    tf2_ros
    visualization_msgs
)

catkin_package(
  INCLUDE_DIRS
    include
  CATKIN_DEPENDS
    actionlib
    camera_calibration_parsers
    cv_bridge
    geometry_msgs
    kdl_parser
    moveit_msgs
    nav_msgs
    pluginlib
    robot_calibration_msgs
    rosbag
    roscpp
    sensor_msgs
    std_msgs
    tf
    tf2_geometry_msgs
    tf2_ros
  DEPENDS
    Boost
    orocos_kdl
  LIBRARIES
    robot_calibration
    robot_calibration_feature_finders
)

if (CATKIN_ENABLE_TESTING AND ENABLE_COVERAGE_TESTING)
  find_package(code_coverage REQUIRED)
  APPEND_COVERAGE_COMPILER_FLAGS()
endif()

include_directories(include ${Boost_INCLUDE_DIRS}
                            ${catkin_INCLUDE_DIRS}
                            ${CERES_INCLUDES}
                            ${orocos_kdl_INCLUDE_DIRS})
link_directories(${orocos_kdl_LIBRARY_DIRS}) # this is a hack, will eventually be unneeded once orocos-kdl is fixed

add_executable(calibrate_base src/calibrate_base.cpp)
target_link_libraries(calibrate_base ${Boost_LIBRARIES}
                                     ${catkin_LIBRARIES})

add_executable(magnetometer_calibration src/magnetometer_calibration.cpp)
target_link_libraries(magnetometer_calibration
  ${Boost_LIBRARIES}
  ${catkin_LIBRARIES}
  ${CERES_LIBRARIES})

add_library(robot_calibration src/calibration_offset_parser.cpp
                              src/chain_manager.cpp
                              src/models.cpp
                              src/optimization_params.cpp
                              src/optimizer.cpp)
target_link_libraries(robot_calibration ${Boost_LIBRARIES}
                                        ${catkin_LIBRARIES}
                                        ${CERES_LIBRARIES}
                                        ${tinyxml_LIBRARIES}
                                        ${orocos_kdl_LIBRARIES})
add_dependencies(robot_calibration robot_calibration_msgs_generate_messages_cpp)

add_library(robot_calibration_feature_finders src/finders/checkerboard_finder.cpp
                                              src/finders/led_finder.cpp
                                              src/finders/plane_finder.cpp)
target_link_libraries(robot_calibration_feature_finders robot_calibration
                                                        ${Boost_LIBRARIES}
                                                        ${catkin_LIBRARIES}
                                                        ${tinyxml_LIBRARIES}
                                                        ${orocos_kdl_LIBRARIES}
                                                        ${OpenCV_LIBS})
add_dependencies(robot_calibration_feature_finders robot_calibration_msgs_generate_messages_cpp)

add_executable(calibrate src/calibrate.cpp)
target_link_libraries(calibrate robot_calibration
                                ${Boost_LIBRARIES}
                                ${catkin_LIBRARIES}
                                ${CERES_LIBRARIES}
                                ${tinyxml_LIBRARIES}
                                ${orocos_kdl_LIBRARIES}
                                ${OpenCV_LIBS})
add_dependencies(calibrate robot_calibration)

add_executable(to_rpy src/tools/to_rpy.cpp)
target_link_libraries(to_rpy robot_calibration
                             ${Boost_LIBRARIES}
                             ${catkin_LIBRARIES}
                             ${orocos_kdl_LIBRARIES})
add_dependencies(to_rpy robot_calibration)

add_executable(viz src/tools/viz.cpp)
target_link_libraries(viz robot_calibration
                             ${Boost_LIBRARIES}
                             ${catkin_LIBRARIES}
                             ${orocos_kdl_LIBRARIES})
add_dependencies(viz robot_calibration)

add_subdirectory(test)

install(DIRECTORY include/ DESTINATION include)

install(TARGETS
	calibrate
	calibrate_base
	robot_calibration
	robot_calibration_feature_finders
	to_rpy
	viz
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
 )

install(FILES robot_calibration.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

=== test/CMakeLists.txt ===
if(CATKIN_ENABLE_TESTING)

find_package(rostest REQUIRED)

catkin_add_gtest(calibration_offset_parser_tests calibration_offset_parser_tests.cpp)
target_link_libraries(calibration_offset_parser_tests robot_calibration
                                                      ${Boost_LIBRARIES}
                                                      ${catkin_LIBRARIES}
                                                      ${orocos_kdl_LIBRARIES}
                                                      ${tinyxml_LIBRARIES})

catkin_add_gtest(rotation_tests rotation_tests.cpp)
target_link_libraries(rotation_tests robot_calibration
                                     ${Boost_LIBRARIES}
                                     ${catkin_LIBRARIES}
                                     ${CERES_LIBRARIES}
                                     ${orocos_kdl_LIBRARIES})

add_executable(camera_info_tests camera_info_tests.cpp)
add_dependencies(tests camera_info_tests)
target_link_libraries(camera_info_tests robot_calibration
                                  ${Boost_LIBRARIES}
                                  ${catkin_LIBRARIES}
                                  ${GTEST_LIBRARIES})

add_executable(chain_manager_tests chain_manager_tests.cpp)
add_dependencies(tests chain_manager_tests)
target_link_libraries(chain_manager_tests robot_calibration
                                          ${Boost_LIBRARIES}
                                          ${catkin_LIBRARIES}
                                          ${GTEST_LIBRARIES})

add_executable(error_block_tests error_block_tests.cpp)
add_dependencies(tests error_block_tests)
target_link_libraries(error_block_tests robot_calibration
                                        ${Boost_LIBRARIES}
                                        ${catkin_LIBRARIES}
                                        ${CERES_LIBRARIES}
                                        ${GTEST_LIBRARIES}
                                        ${orocos_kdl_LIBRARIES})

add_executable(error_block_tests2 error_block_tests2.cpp)
add_dependencies(tests error_block_tests2)
target_link_libraries(error_block_tests2 robot_calibration
                                         ${Boost_LIBRARIES}
                                         ${catkin_LIBRARIES}
                                         ${CERES_LIBRARIES}
                                         ${GTEST_LIBRARIES}
                                         ${orocos_kdl_LIBRARIES})

add_executable(feature_finder_loader_tests feature_finder_loader_tests.cpp)
add_dependencies(tests feature_finder_loader_tests)
target_link_libraries(feature_finder_loader_tests robot_calibration
                                                  ${Boost_LIBRARIES}
                                                  ${catkin_LIBRARIES}
                                                  ${GTEST_LIBRARIES})

add_executable(optimization_param_tests optimization_param_tests.cpp)
add_dependencies(tests optimization_param_tests)
target_link_libraries(optimization_param_tests robot_calibration
                                               ${Boost_LIBRARIES}
                                               ${catkin_LIBRARIES}
                                               ${GTEST_LIBRARIES})

add_rostest(camera_info_tests.test)
add_rostest(chain_manager_tests.test)
add_rostest(feature_finder_loader_tests.test)
add_rostest(optimization_param_tests.test)
add_rostest(error_block_tests.test)
add_rostest(error_block_tests2.test)

if(ENABLE_COVERAGE_TESTING)
  set(COVERAGE_EXCLUDES "*/${PROJECT_NAME}/test*")
  add_code_coverage(
    NAME ${PROJECT_NAME}_coverage_report
    DEPENDS tests
  )
endif()

endif()  # if CATKIN_ENABLE_TESTING

=== debian/changelog ===
ros-kinetic-robot-calibration (0.6.3-1xenial) xenial; urgency=high

  * kinetic requires C++11, but doesn't specify it (#85 <https://github.com/mikeferguson/robot_calibration/issues/85>)
  * note topics being published/subscribed
  * some fixes for magnetometer cal (#84 <https://github.com/mikeferguson/robot_calibration/issues/84>)
    * the spinOnce was needed
    * exit properly on CTRL-C
  * add magnetometer calibration node (#83 <https://github.com/mikeferguson/robot_calibration/issues/83>)
  * remove readme, top level one has docs
  * add travis and code coverage (#80 <https://github.com/mikeferguson/robot_calibration/issues/80>)
  * export feature_finders lib
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mike@vanadiumlabs.com>  Mon, 27 Apr 2020 04:00:00 -0000

ros-kinetic-robot-calibration (0.6.2-1xenial) xenial; urgency=high

  * Merge pull request #75 <https://github.com/mikeferguson/robot_calibration/issues/75> from mikeferguson/mute_warnings
    fix warnings about build type
  * fix warnings about build type
  * Merge pull request #74 <https://github.com/mikeferguson/robot_calibration/issues/74> from mikeferguson/fix_tests
    fix tests broken by #71 <https://github.com/mikeferguson/robot_calibration/issues/71>
  * fix tests broken by #71 <https://github.com/mikeferguson/robot_calibration/issues/71>
  * Merge pull request #71 <https://github.com/mikeferguson/robot_calibration/issues/71> from Naoki-Hiraoka/fix-calculation-of-frame_offset
    Fix calculation of frame offset
  * Merge pull request #73 <https://github.com/mikeferguson/robot_calibration/issues/73> from mikeferguson/multi-step
    Support multi-step optimization
  * Merge pull request #68 <https://github.com/mikeferguson/robot_calibration/issues/68> from d-walsh/bugfix/isnan_error
    Fixed isnan() error on Kinetic
  * refactor mutli-step support
  * enable multi-step optimization
  * fix frame calculation in getChainFK()
  * fix calculation of frame_offset
  * Fixed isnan() error on Kinetic
  * Contributors: David Walsh, Michael Ferguson, Naoki-Hiraoka

 -- Michael Ferguson <mike@vanadiumlabs.com>  Tue, 14 Jan 2020 05:00:00 -0000

ros-kinetic-robot-calibration (0.6.1-1xenial) xenial; urgency=high

  * Merge pull request #70 <https://github.com/mikeferguson/robot_calibration/issues/70> from Naoki-Hiraoka/enable-to-change-driver-name
    Enable to change driver name
  * Merge pull request #69 <https://github.com/mikeferguson/robot_calibration/issues/69> from Naoki-Hiraoka/allow-multiple-checkerboards
    Use multiple checkerboards
  * enable to change driver name
  * allow multiple checkerboards
  * Merge pull request #56 <https://github.com/mikeferguson/robot_calibration/issues/56> from mikeferguson/coverage
    add code coverage testing
  * update code_coverage to be test_depend
  * add code coverage testing
  * Contributors: Michael Ferguson, Naoki-Hiraoka

 -- Michael Ferguson <mike@vanadiumlabs.com>  Tue, 19 Nov 2019 05:00:00 -0000

ros-kinetic-robot-calibration (0.6.0-1xenial) xenial; urgency=high

  * install our new tools
  * add depend on visualization_msgs
  * Merge pull request #63 <https://github.com/mikeferguson/robot_calibration/issues/63> from mikeferguson/checkerboards_that_work
    Make checkerboards actually generic
  * Merge pull request #62 <https://github.com/mikeferguson/robot_calibration/issues/62> from mikeferguson/chain_manager_state_fix
    make sure we get valid joint_states
  * make sure we get valid joint_states
    * invalid old state, wait for new message
    * fixes #61 <https://github.com/mikeferguson/robot_calibration/issues/61>
  * Merge pull request #59 <https://github.com/mikeferguson/robot_calibration/issues/59> from saurabhbansal90/master
    Update led_finder.cpp
  * Update led_finder.cpp
  * additional tests on camera_info
  * fix build in kinetic
  * remove entirely unused data functions header
  * fix corrupted license file
  * additional warning not previously flagged
  * buildfarm is really picky, fix another signed comparison
  * fix signed comparison warning in tests
  * add tool to visualize bagfile
  * break out load_bag function for reuse
  * towards working checkerboards
    * unhack the checkerboard finder, so that points are in x/y only
    * add free_frames_initial_values parameter for setting initial
    offset of checkerboard frame
  * Merge pull request #52 <https://github.com/mikeferguson/robot_calibration/issues/52> from mikeferguson/melodic-backport
    backport changes from melodic-devel branch
  * fix OutrageousError
    This has apparently NEVER worked. The name that was being
    provided was the error block name, not the name of the
    parameter to limit.
  * add to_rpy tool
    The YAML file output by calibration represents angles in
    the internal axis-magnitude notation. RPY tends to be
    easier for people to understand and visualize.
  * add some comments to Camera3dModel
    In particular, a search for checkerboard should really turn up this
    important piece of code
  * fix test build/warning issues on 18.04
  * Merge pull request #50 <https://github.com/mikeferguson/robot_calibration/issues/50> from guilhermelawless/tf-buffer-member
    Make TF buffer a class member
  * make TF buffer a class member
    Fixes #48 <https://github.com/mikeferguson/robot_calibration/issues/48>. Sleeping to wait for TFs is no longer needed and was removed.
  * Merge pull request #47 <https://github.com/mikeferguson/robot_calibration/issues/47> from guilhermelawless/fix-checkerboard-visualization
    Fix checkerboard visualization
  * Merge pull request #45 <https://github.com/mikeferguson/robot_calibration/issues/45> from guilhermelawless/kinetic-devel
    Allow some time to get TFs in plane_finder
  * fix checkerboard visualization msg
  * allow some time to get TFs in plane_finder
  * add a second error block test, that actually needs to converge
  * fix parameter name in test, fork a second copy
  * make sure solver ran in test


=== debian/control ===
Source: ros-kinetic-robot-calibration
Section: misc
Priority: optional
Maintainer: Michael Ferguson <mike@vanadiumlabs.com>
Build-Depends: debhelper (>= 9.0.0), libceres-dev, libgflags-dev, libprotobuf-dev, libprotoc-dev, libsuitesparse-dev, protobuf-compiler, ros-kinetic-actionlib, ros-kinetic-camera-calibration-parsers, ros-kinetic-catkin, ros-kinetic-code-coverage, ros-kinetic-control-msgs, ros-kinetic-cv-bridge, ros-kinetic-geometry-msgs, ros-kinetic-kdl-parser, ros-kinetic-moveit-msgs, ros-kinetic-nav-msgs, ros-kinetic-orocos-kdl, ros-kinetic-pluginlib, ros-kinetic-robot-calibration-msgs, ros-kinetic-rosbag, ros-kinetic-roscpp, ros-kinetic-sensor-msgs, ros-kinetic-std-msgs, ros-kinetic-tf, ros-kinetic-tf2-geometry-msgs, ros-kinetic-tf2-ros, ros-kinetic-visualization-msgs
Homepage: http://ros.org/wiki/robot_calibration
Standards-Version: 3.9.2

Package: ros-kinetic-robot-calibration
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libceres-dev, libprotobuf-dev, libprotoc-dev, libsuitesparse-dev, protobuf-compiler, ros-kinetic-actionlib, ros-kinetic-camera-calibration-parsers, ros-kinetic-control-msgs, ros-kinetic-cv-bridge, ros-kinetic-geometry-msgs, ros-kinetic-kdl-parser, ros-kinetic-moveit-msgs, ros-kinetic-nav-msgs, ros-kinetic-orocos-kdl, ros-kinetic-pluginlib, ros-kinetic-robot-calibration-msgs, ros-kinetic-rosbag, ros-kinetic-roscpp, ros-kinetic-sensor-msgs, ros-kinetic-std-msgs, ros-kinetic-tf, ros-kinetic-tf2-geometry-msgs, ros-kinetic-tf2-ros, ros-kinetic-visualization-msgs
Description: Calibrate a Robot

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-robot-calibration//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
